function [BestC,BestG,Gmean] = ModelSelection(train_l,traindata,Nweight,Pweight,Model_Selec,Multilevel,MoS_UB,coarse,id,C1,G1)

[n m] = size(traindata);

if Model_Selec == 0 
    BestC = 100;
    BestG = 0.5;   % 0.5;
    Gmean = 0.9;
    
    
elseif (n>MoS_UB) && Multilevel==1  && coarse == 0
        %  sprintf('no model selection')
    
        %    sprintf('\t inherit model selection')
        BestC = C1;%100;
        BestG = G1;%0.5;   % 0.5;
        Gmean = 0.9;
else
%id=1;         % shows the library SVM is working
%id=2;         % shows the library WSVM is working
%sprintf('\t run model selection')
ParamsR.t=0;ParamsR.r=1;ParamsR.v=10;ParamsR.p=0;
Design= '9-5'; % '13-9'

if (ischar(Design))
    ParamsR.Design=strread(Design, '%f', 'delimiter', '-');
end

if id==1
    C_Range = [-6.64385619 6.64385619];
else
    C_Range = [-6.64385619 10.5507468];
end
% determine the range of gamma
G_Range = [-7.6439, 1.5850];
%===============================
% Start our selection procedure
%===============================
if(nargin < 10)
    Center = [sum(C_Range)/2,sum(G_Range)/2,0.25];
else
    Center = [ log2(C1),log2(G1),0.25];
end
%----------------------
% [Pdata,Ndata,Plbl,Nlbl] = Imbalanced(traindata,train_l,1);   % To divide the dataset into minority(Pdata,Plbl) and majority(Ndata,Nlbl) class
% r = randperm(numel(Nlbl));        % chooses rows randomly and put it in matrix r
% tot = floor(numel(Nlbl)*.4);      % 90% data is chosen for train, 10% for test, tot: majority class size
% train_l1 = Nlbl(r(1:tot));        % train lables
% traindata1 = Ndata(r(1:tot),:);
% s = randperm(numel(Plbl));      %chooses rows randomly and put it in matrix r
% sot = floor(numel(Plbl)*.4);    % 90% data is chosen for train, 10% for test,s sot: minority class size
% train_l2 = Plbl(s(1:sot));       %train lables
% traindata2 = Pdata(s(1:sot),:);
% Pweight = 1/size(traindata2,1);                       % The inverse size of minority class
% Nweight = 1/size(traindata1,1);                       % The inverse size of majority class
% train_l = [train_l1; train_l2];
% traindata = [traindata1; traindata2];
%-----------------------
[UDPts1] = UDSampleRSVM(id, C_Range, G_Range, 1, ParamsR.Design(1), 'class', Center);    % decide training points in 1st stage
GMean1 = GridExploreRSVM(train_l, traindata, UDPts1, ParamsR, Nweight, Pweight, id);
[GMeantemp,ind1]=max(GMean1); Center=UDPts1(ind1,:);             % decide the center of searching box in 2nd stage
%-----------------------------------------------
[UDPts2] = UDSampleRSVM(id, C_Range, G_Range, 2, ParamsR.Design(2), 'class', Center); % decide training points in 2nd stage
%------------------------------------------------
UDPts2=UDPts2(2:size(UDPts2,1),:);                               % remove the center to avoid duplicate computation
GMean2 = GridExploreRSVM(train_l, traindata, UDPts2, ParamsR, Nweight, Pweight, id); % Training in 2nd stage
GMeanAll = [GMean1; GMean2];
Points = [UDPts1; UDPts2];

% determine the optimal model
[Gmean,ind]=max(GMeanAll);
BestC=2^Points(ind,1); BestG=2^Points(ind,2);
end
% Clog=Points(ind,1); Wlog=Points(ind,2);